<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <div class="wp-12 wp-layout wp-layout--no-pad">
        <wp-input type="switch" v-model="rolePermission.create"
          label="Создание"/>
        <wp-input type="switch" v-model="rolePermission.read"
          label="Просмотр"/>
        <wp-input type="switch" v-model="rolePermission.update"
          label="Изменение"/>
        <wp-input type="switch" v-model="rolePermission.delete"
          label="Удаление"/>
        <wp-input type="switch" v-model="rolePermission.self"
          label="Ограничение"/>
      </div>
      <wp-input class="wp-12" type="dropdown" v-model="rolePermission.type"
        @input="resetResource" label="Тип разрешения"
        placeholder="Выберите тип" :items="permissionTypes"/>
      <wp-input class="wp-12" type="autocomplete" v-model="rolePermission.resource"
        label="Распространяется на" placeholder="Начните ввод для поиска" :items="resources"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="submit">
        Сохранить изменения
      </button>
      <button v-if="isEditing" class="wp-button wp-button--delete" @click="removePermission">
        Удалить
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import { PermissionsTypes } from '@/shared';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'RolePermissionAdvanced',
  components: {
    WpInput,
  },
  data() {
    return {
      permissionTypes: [
        {
          text: 'Организация',
          prop: PermissionsTypes.Organization,
        },
        {
          text: 'Участники',
          prop: PermissionsTypes.Members,
        },
        {
          text: 'Роли',
          prop: PermissionsTypes.Roles,
        },
        {
          text: 'Причины',
          prop: PermissionsTypes.Reasons,
        },
        {
          text: 'Категории',
          prop: PermissionsTypes.Categories,
        },
        {
          text: 'Команды',
          prop: PermissionsTypes.Groups,
        },
        {
          text: 'Оценки',
          prop: PermissionsTypes.Grades,
        },
      ],
      rolePermission: {
        role: null,
        type: undefined,
        resource: undefined,
        self: false,
        create: false,
        read: false,
        update: false,
        delete: false,
      },
      PermissionsTypes,
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
    role: {
      type: Object,
      default: () => undefined,
    },
  },
  computed: {
    ...mapState('session', ['selectedOrganization']),
    ...mapState('organization', [
      'organization',
      'members',
      'roles',
      'groups',
      'categories',
      'reasons',
    ]),
    resources() {
      const result = [{
        prop: null,
        text: 'Общее разрешение',
      }];
      switch (this.rolePermission.type) {
        case PermissionsTypes.Organization: {
          result.push({
            prop: this.selectedOrganization,
            text: this.organization.name,
          });
          return result;
        }
        case PermissionsTypes.Members: {
          const members = this.members.map(item => ({
            text: item.email,
            prop: item.id,
          }));
          result.push(...members);
          return result;
        }
        case PermissionsTypes.Roles: {
          const roles = this.roles.map(item => ({
            text: item.name,
            prop: item.id,
          }));
          result.push(...roles);
          return result;
        }
        case PermissionsTypes.Reasons: {
          const reasons = this.reasons.map(item => ({
            text: item.text,
            prop: item.id,
          }));
          result.push(...reasons);
          return result;
        }
        case PermissionsTypes.Categories: {
          const categories = this.categories.map(item => ({
            text: item.name,
            prop: item.id,
          }));
          result.push(...categories);
          return result;
        }
        case PermissionsTypes.Groups: {
          const groups = this.groups.map(item => ({
            text: item.name,
            prop: item.id,
          }));
          result.push(...groups);
          return result;
        }
        case PermissionsTypes.Grades: {
          const categories = this.categories.map(item => ({
            text: item.name,
            prop: item.id,
          }));
          result.push(...categories);
          return result;
        }
        default: return [];
      }
    },
    isEditing() {
      return !!this.$props.data;
    },
  },
  methods: {
    ...mapActions('organization', [
      'createRolePermissions',
      'updateRolePermission',
      'deleteRolePermission',
    ]),
    resetResource() {
      this.rolePermission.resource = undefined;
    },
    submit() {
      if (this.$props.data) {
        this.editRolePermission();
      } else {
        this.addRolePermission();
      }
    },
    async addRolePermission() {
      try {
        this.rolePermission.role = this.$props.role.id;
        this.rolePermission.permissions = [{
          type: this.rolePermission.type,
          self: this.rolePermission.self,
          resource: this.rolePermission.resource,
          create: this.rolePermission.create,
          read: this.rolePermission.read,
          update: this.rolePermission.update,
          delete: this.rolePermission.delete,
        }];
        await this.createRolePermissions(this.rolePermission);
        this.$toasted.success('Разрешение создано');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async editRolePermission() {
      try {
        await this.updateRolePermission(this.rolePermission);
        this.$toasted.success('Разрешение изменено');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async removePermission() {
      try {
        await this.deleteRolePermission(this.rolePermission.id);
        this.$toasted.success('Разрешение удалено');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    if (this.$props.data) {
      this.rolePermission = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
